//+---------------------------------------------------------------------+ 
//|                                                            XKVO.mq5 | 
//|                                  Copyright  2011, Nikolay Kositsin | 
//|                                 Khabarovsk,   farria@mail.redcom.ru | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): MetaTrader\\MQL5\Include                      |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----    4
#property indicator_buffers 4 
//----     
#property indicator_plots   2
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1 DRAW_COLOR_HISTOGRAM
//----      
#property indicator_color1 Gray,LimeGreen,Green,Red,PaleVioletRed
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "XKVO"

//----      
#property indicator_type2 DRAW_COLOR_LINE
//----      
#property indicator_color2 Gray,Aqua,Magenta
//----   -  
#property indicator_style2 STYLE_DASHDOTDOT
//----     3
#property indicator_width2 3
//----    
#property indicator_label2  "Signal Line"
//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA1,XMA2,XMA3;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPL_,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method MA_SMethod=MODE_EMA;           //   
input int Fast_XMA = 34;                           //   
input int Slow_XMA = 55;                           //   
input int SmPhase= 100;                            //   ,
input Smooth_Method Signal_Method=MODE_EMA;        //    
input int Signal_XMA=13;                           //    
input int Signal_Phase=100;                        //   ,
input Applied_price_ AppliedPrice=PRICE_CLOSE_;    //  
input ENUM_APPLIED_VOLUME VolumeType=VOLUME_TICK;  // 
//----      
int start,xkvo_start;
//----   ,    
//----      
double XKVOBuffer[],SignBuffer[],ColorXKVOBuffer[],ColorSignBuffer[];
//+------------------------------------------------------------------+
//|   iPriceSeries                                    |
//|   Moving_Average                                   | 
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+    
//| XKVO indicator initialization function                           | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   xkvo_start=MathMax(XMA1.GetStartBars(MA_SMethod,Fast_XMA,SmPhase),XMA1.GetStartBars(MA_SMethod,Slow_XMA,SmPhase))+1;
   start=xkvo_start+XMA1.GetStartBars(Signal_Method,Signal_XMA,Signal_Phase)+1;

//----    XKVOBuffer[]   
   SetIndexBuffer(0,XKVOBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,xkvo_start);
//----      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"XKVO");
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    ColorXKVOBuffer[]       
   SetIndexBuffer(1,ColorXKVOBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,xkvo_start+1);

//----    SignBuffer[]   
   SetIndexBuffer(2,SignBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,start);
//----      DataWindow
   PlotIndexSetString(2,PLOT_LABEL,"Signal XKVO");
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    ColorSignBuffer[]       
   SetIndexBuffer(3,ColorSignBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,start+1);

//----       
   XMA1.XMALengthCheck("Fast_XMA", Fast_XMA);
   XMA1.XMALengthCheck("Slow_XMA", Slow_XMA);
   XMA1.XMALengthCheck("Signal_XMA", Signal_XMA);
//----       
   XMA1.XMAPhaseCheck("Phase", SmPhase, MA_SMethod);
   XMA1.XMAPhaseCheck("Signal_Phase", Signal_Phase, Signal_Method);

//----      
   string shortname;
   string Smooth1=XMA1.GetString_MA_Method(MA_SMethod);
   string Smooth2=XMA1.GetString_MA_Method(Signal_Method);
   StringConcatenate(shortname,
                     "XKVO( ",Fast_XMA,", ",Slow_XMA,", ",Signal_XMA,", ",Smooth1,", ",Smooth2," )");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+  
//| XKVO iteration function                                          | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<start) return(0);

//----   
   int first1,first2,first3,bar;
//----       
   double tpc,tpp,var=0.0,vol,fast_xma,slow_xma,xkvo,sign_xkvo;

//----     OnCalculate()
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      first1=1;            //        
      first2=xkvo_start+2; //        
      first3=start+2;      //        
     }
   else //      
     {
      first1=prev_calculated-1;
      first2=first1;
      first3=first1;
     }

//----    
   for(bar=first1; bar<rates_total; bar++)
     {
      tpc = (low[bar] + close[bar] + close[bar])/3;
      tpp = (high[bar-1] + low[bar-1] + close[bar-1])/3;
      if(VolumeType==VOLUME_TICK) vol=double(tick_volume[bar]);
      else                        vol=double(volume[bar]);

      if(tpc > tpp) var = vol;
      if(tpc < tpp) var = -vol;
      if(tpc==tpp) var=0.0;

      fast_xma = XMA1.XMASeries(1, prev_calculated, rates_total, MA_SMethod, SmPhase, Fast_XMA, var, bar, false);
      slow_xma = XMA2.XMASeries(1, prev_calculated, rates_total, MA_SMethod, SmPhase, Slow_XMA, var, bar, false);

      xkvo=fast_xma-slow_xma;
      sign_xkvo=XMA3.XMASeries(xkvo_start,prev_calculated,rates_total,Signal_Method,Signal_Phase,Signal_XMA,xkvo,bar,false);

      //----            
      XKVOBuffer[bar]= xkvo;
      SignBuffer[bar]= sign_xkvo;
     }

//----     XKVO
   for(bar=first2; bar<rates_total; bar++)
     {
      ColorXKVOBuffer[bar]=0;

      if(XKVOBuffer[bar]>0)
        {
         if(XKVOBuffer[bar]>XKVOBuffer[bar-1]) ColorXKVOBuffer[bar]=1;
         if(XKVOBuffer[bar]<XKVOBuffer[bar-1]) ColorXKVOBuffer[bar]=2;
        }

      if(XKVOBuffer[bar]<0)
        {
         if(XKVOBuffer[bar]<XKVOBuffer[bar-1]) ColorXKVOBuffer[bar]=3;
         if(XKVOBuffer[bar]>XKVOBuffer[bar-1]) ColorXKVOBuffer[bar]=4;
        }
     }

//----     
   for(bar=first3; bar<rates_total; bar++)
     {
      ColorSignBuffer[bar]=0;
      if(XKVOBuffer[bar]>SignBuffer[bar-1]) ColorSignBuffer[bar]=1;
      if(XKVOBuffer[bar]<SignBuffer[bar-1]) ColorSignBuffer[bar]=2;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
